const config = require('../../config');
const providers = config.providers;
const crypto = require('crypto');
const bcrypt = require('bcrypt');
const moment = require('moment');

module.exports = function (sequelize, DataTypes) {
  const compliance_issues = sequelize.define(
    'compliance_issues',
    {
      id: {
        type: DataTypes.UUID,
        defaultValue: DataTypes.UUIDV4,
        primaryKey: true,
      },

      category: {
        type: DataTypes.ENUM,

        values: ['security', 'privacy', 'billing'],
      },

      description: {
        type: DataTypes.TEXT,
      },

      severity: {
        type: DataTypes.ENUM,

        values: ['low', 'medium', 'high', 'critical'],
      },

      status: {
        type: DataTypes.ENUM,

        values: ['open', 'in_progress', 'resolved'],
      },

      importHash: {
        type: DataTypes.STRING(255),
        allowNull: true,
        unique: true,
      },
    },
    {
      timestamps: true,
      paranoid: true,
      freezeTableName: true,
    },
  );

  compliance_issues.associate = (db) => {
    /// loop through entities and it's fields, and if ref === current e[name] and create relation has many on parent entity

    //end loop

    db.compliance_issues.belongsTo(db.organizations, {
      as: 'organization',
      foreignKey: {
        name: 'organizationId',
      },
      constraints: false,
    });

    db.compliance_issues.belongsTo(db.users, {
      as: 'owner',
      foreignKey: {
        name: 'ownerId',
      },
      constraints: false,
    });

    db.compliance_issues.belongsTo(db.organizations, {
      as: 'organizations',
      foreignKey: {
        name: 'organizationsId',
      },
      constraints: false,
    });

    db.compliance_issues.belongsTo(db.users, {
      as: 'createdBy',
    });

    db.compliance_issues.belongsTo(db.users, {
      as: 'updatedBy',
    });
  };

  return compliance_issues;
};
